package sim.app.AmaSim;

import sim.engine.*;
import sim.util.*;
import sim.field.continuous.*;

//===============================================
public class Community implements Steppable, Runnable
{ 

int number;

AmaSim agent;

Thread t;

static AmaSimWorld sync;
static String[] args;
long tStart;	
long tAct;		

String name = "";

//===============================================
public Community(long seed, int pnumber, AmaSimWorld syncObj)
{
    number = pnumber;

    agent = new AmaSim(seed);

    agent.community = this;

    t = new Thread(this);

    sync = syncObj;

    name = "Comm" + number;
    System.out.println ("Community: " + name + " created");

}

//===============================================
public  void run()
{
    agent.start();

    tStart = System.currentTimeMillis();

    synchronized(sync){
        do{ 
            agent.schedule.step(agent);

            sync.readyCommunities++;   

            if(sync.readyCommunities >= sync.numCom)
            {
                sync.schedule.step(sync);
                sync.readyCommunities = 0;
                sync.notifyAll();
            }
            else
            { 
                try{
                    sync.wait();                    
                }catch(InterruptedException e){}
            }
        }while(agent.schedule.getTime() < agent.num_step);
    }
}

//===============================================
public void init()
{

    //System.out.println ("========Simulation Starts======================");        
    agent.outDirCom = sync.outDir + "/" + this.name;

    agent.global_input_fileCom = sync.global_input_file + this.name;


}

//===============================================
public  void step(SimState state)
{
    long dt;
    if((agent.schedule.getSteps() % 100 ) == 0)
    {              
        dt = System.currentTimeMillis() - this.tStart;

        System.out.println(" Com " + t.getName() + " Step "+ agent.schedule.getSteps() + " Step Time" + dt/agent.schedule.getSteps());  

    }

}

//===============================================
public void startThread()
{
    t.start();
}

//===============================================
public long getagentSteps()
{
    return agent.schedule.getSteps();
}




}//End of file

